mod Ex03b logic: 'cl'

incl Mtex

incl Mtexg

loc rem 
  \para \bf  3. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.20 
  \para* \it  Dátum:  \end streda 5.3.2014 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1314ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované explicitným 
  definíciam. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Explicit Definitions.  \end 

theory Exercise1

rem 
  \para \bf  Exercise.  \end \header* fun/3 F 'Tex_f3_f' \end Find an explicit 
  definition of the ternary function \ft F(x,y,z) \end satisfying 
  \eq* 
    x < y \/ x >= z -> F(x,y,z) = 1
  \end
  \eq* 
    ~(x < y \/ x >= z) -> F(x,y,z) = 2
  \end
  \para Prove that the function has the required properties. Otherwise, show 
  that there is no such function. 

theory Solvable

fun/3 F 'Tex_f3_f'
  F(x,y,z) = Foo

thm Spec1
  x < y \/ x >= z -> F(x,y,z) = 1

thm Spec2
  ~(x < y \/ x >= z) -> F(x,y,z) = 2

end theory Solvable

theory Unsolvable

fun/3 F 'Tex_f3_f'

axiom Spec1
  x < y \/ x >= z -> F(x,y,z) = 1

axiom Spec2
  ~(x < y \/ x >= z) -> F(x,y,z) = 2

thm Inconsistency
  \f

end theory Unsolvable

end theory Exercise1

theory Exercise2

rem 
  \para \bf  Exercise.  \end \header* fun/3 F 'Tex_f3_f' \end Find an explicit 
  definition of the ternary function \ft F(x,y,z) \end satisfying 
  \eq* 
    x < y+z \/ x > y & x > z -> F(x,y,z) = 1
  \end
  \eq* 
    ~(x < y+z \/ x > y & x > z) -> F(x,y,z) = 2
  \end
  \para Prove that the function has the required properties. Otherwise, show 
  that there is no such function. 

theory Solvable

fun/3 F 'Tex_f3_f'
  F(x,y,z) = Foo

thm Spec1
  x < y+z \/ x > y & x > z -> F(x,y,z) = 1

thm Spec2
  ~(x < y+z \/ x > y & x > z) -> F(x,y,z) = 2

end theory Solvable

theory Unsolvable

fun/3 F 'Tex_f3_f'

axiom Spec1
  x < y+z \/ x > y & x > z -> F(x,y,z) = 1

axiom Spec2
  ~(x < y+z \/ x > y & x > z) -> F(x,y,z) = 2

thm Inconsistency
  \f

end theory Unsolvable

end theory Exercise2

theory Exercise3

rem 
  \para \bf  Exercise.  \end \header* fun/3 F 'Tex_f3_f' \end Find an explicit 
  definition of the ternary function \ft F(x,y,z) \end satisfying 
  \eq* 
    x > y -> F(x,y,z) = 1
  \end
  \eq* 
    x > z -> F(x,y,z) = 2
  \end
  \eq* 
    ~(x > y \/ x > z) -> F(x,y,z) = 3
  \end
  \para Prove that the function has the required properties. Otherwise, show 
  that there is no such function. 

theory Solvable

fun/3 F 'Tex_f3_f'
  F(x,y,z) = Foo

thm Spec1
  x > y -> F(x,y,z) = 1

thm Spec2
  x > z -> F(x,y,z) = 2

thm Spec3
  ~(x > y \/ x > z) -> F(x,y,z) = 3

end theory Solvable

theory Unsolvable

fun/3 F 'Tex_f3_f'

axiom Spec1
  x > y -> F(x,y,z) = 1

axiom Spec2
  x > z -> F(x,y,z) = 2

axiom Spec3
  ~(x > y \/ x > z) -> F(x,y,z) = 3

thm Inconsistency
  \f

end theory Unsolvable

end theory Exercise3

theory Exercise4

rem 
  \para \bf  Exercise.  \end \header* fun/3 F 'Tex_f3_f' \end Find an explicit 
  definition of the ternary function \ft F(x,y,z) \end satisfying 
  \eq* 
    x > y+z -> F(x,y,z) = 1
  \end
  \eq* 
    x < y -> F(x,y,z) = 2
  \end
  \eq* 
    ~(x > y+z \/ x < y) -> F(x,y,z) = 3
  \end
  \para Prove that the function has the required properties. Otherwise, show 
  that there is no such function. 

theory Solvable

fun/3 F 'Tex_f3_f'
  F(x,y,z) = Foo

thm Spec1
  x > y+z -> F(x,y,z) = 1

thm Spec2
  x < y -> F(x,y,z) = 2

thm Spec3
  ~(x > y+z \/ x < y) -> F(x,y,z) = 3

end theory Solvable

theory Unsolvable

fun/3 F 'Tex_f3_f'

axiom Spec1
  x > y+z -> F(x,y,z) = 1

axiom Spec2
  x < y -> F(x,y,z) = 2

axiom Spec3
  ~(x > y+z \/ x < y) -> F(x,y,z) = 3

thm Inconsistency
  \f

end theory Unsolvable

end theory Exercise4

theory Exercise5

rem 
  \para \bf  Exercise.  \end \header* fun/3 F 'Tex_f3_f' \end Find an explicit 
  definition of the ternary function \ft F(x,y,z) \end satisfying 
  \eq* 
    x < y+z -> F(x,y,z) = 1
  \end
  \eq* 
    x > y -> F(x,y,z) = 2
  \end
  \eq* 
    ~(x < y+z \/ x > y) -> F(x,y,z) = 3
  \end
  \para Prove that the function has the required properties. Otherwise, show 
  that there is no such function. 

theory Solvable

fun/3 F 'Tex_f3_f'
  F(x,y,z) = Foo

thm Spec1
  x < y+z -> F(x,y,z) = 1

thm Spec2
  x > y -> F(x,y,z) = 2

thm Spec3
  ~(x < y+z \/ x > y) -> F(x,y,z) = 3

end theory Solvable

theory Unsolvable

fun/3 F 'Tex_f3_f'

axiom Spec1
  x < y+z -> F(x,y,z) = 1

axiom Spec2
  x > y -> F(x,y,z) = 2

axiom Spec3
  ~(x < y+z \/ x > y) -> F(x,y,z) = 3

thm Inconsistency
  \f

end theory Unsolvable

end theory Exercise5

